"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/lib/index.ts
var lib_exports = {};
__export(lib_exports, {
  default: () => lib_default,
  getFiles: () => getFiles,
  readdir: () => readdir
});
module.exports = __toCommonJS(lib_exports);

// src/lib/fs.ts
async function getFiles(dirHandle, recursive = false, path = dirHandle.name, skipDirectory, progress, onProgress) {
  const dirs = [];
  const files = [];
  progress = progress || { loaded: 0, total: 0 };
  for await (const entry of dirHandle.values()) {
    const nestedPath = `${path}/${entry.name}`;
    if (entry.kind === "file") {
      progress.total += 1;
      files.push(
        entry.getFile().then((f) => {
          const file = f;
          file.directoryHandle = dirHandle;
          file.handle = entry;
          progress.loaded += 1;
          onProgress?.(new ProgressEvent("progress", { lengthComputable: true, ...progress }));
          return Object.defineProperty(file, "webkitRelativePath", {
            configurable: true,
            enumerable: true,
            get: () => nestedPath
          });
        })
      );
    } else if (entry.kind === "directory" && recursive && (!skipDirectory || !skipDirectory(entry))) {
      dirs.push(getFiles(entry, recursive, nestedPath, skipDirectory, progress, onProgress));
    }
  }
  return [...(await Promise.all(dirs)).flat(), ...await Promise.all(files)];
}

// src/lib/index.ts
async function readdir(dirHandle, options) {
  return await getFiles(
    dirHandle,
    options?.recursive,
    void 0,
    options?.skipDirectory,
    void 0,
    options?.onProgress
  );
}
var lib_default = readdir;
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  getFiles,
  readdir
});
/**
 * Read contents in a directory from disk using the File System Access API.
 *
 * @license © 2020 Google LLC. Licensed under the Apache License, Version 2.0.
 * @returns Contained files.
 */
//# sourceMappingURL=index.cjs.map